package com.blogspot.lucbors.view.beans;

import com.blogspot.lucbors.view.utils.ADFUtils;

import com.blogspot.lucbors.view.utils.GenericTableSelectionHandler;

import oracle.adf.model.binding.DCIteratorBinding;

import oracle.adf.view.rich.component.rich.data.RichTable;

import oracle.adf.view.rich.context.AdfFacesContext;

import oracle.adfinternal.view.faces.model.binding.FacesCtrlHierNodeBinding;

import oracle.jbo.Row;

import oracle.jbo.uicli.binding.JUCtrlHierNodeBinding;

import org.apache.myfaces.trinidad.event.SelectionEvent;
import org.apache.myfaces.trinidad.model.CollectionModel;
import org.apache.myfaces.trinidad.model.RowKeySetImpl;

public class HighLightBean {
  private RichTable locTable;

  public HighLightBean() {
  }


  public void onCountryTableSelect(SelectionEvent selectionEvent) {
    // your pre-trigger code goes here ...
    GenericTableSelectionHandler.makeCurrent(selectionEvent);
    //your post-trigger code goes here ...

    DCIteratorBinding conIter =
      ADFUtils.findIterator("CountriesView2Iterator");

    matchEm(conIter.getCurrentRow());
  }

  private void matchEm(Row r) {

    RowKeySetImpl newSelection = new RowKeySetImpl();
    locTable.getSelectedRowKeys().clear();

    String countryId = (String)r.getAttribute("CountryId");

    //the CollectionModel provides access to the ADF Binding for this table
    CollectionModel model = (CollectionModel)locTable.getValue();
    
    int rowCount = model.getRowCount();

    for (int i = 0; i < rowCount; i++) {
      model.setRowIndex(i);
      Object rowkey = model.getRowKey();

      JUCtrlHierNodeBinding rowdata = (JUCtrlHierNodeBinding)model.getRowData(i);
      Row loc = rowdata.getRowAtRangeIndex(i);

      if (loc.getAttribute("CountryId").toString().equalsIgnoreCase(countryId)) {
        System.out.println("found a match for  locations " +
                           loc.getAttribute("City"));
        System.out.println("adding key " + loc.getKey());
        newSelection.add(rowkey);
      }
    }

    locTable.setSelectedRowKeys(newSelection);
    AdfFacesContext.getCurrentInstance().addPartialTarget(locTable);

  }

  public void setLocTable(RichTable locTable) {
    this.locTable = locTable;
  }

  public RichTable getLocTable() {
    return locTable;
  }

}
